<?php
//TODO count for categories limit 1
defined('_JEXEC') or die();

jimport('joomla.event.plugin');

class plgContentJcscontent extends JPlugin
{
	function plgContentJcscontent(&$subject, $params)
	{
		parent::__construct($subject, $params);
	}

	function onBeforeDisplayContent(&$article, &$params, $limitstart)
	{
		global $mainframe, $option, $task, $Itemid;

		if ($mainframe->isAdmin())
		return;

		$db = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$userid = $my->get('id');
		$view = JRequest::getWord('view');
		$session = & JFactory::getSession();
		$plugin = & JPluginHelper::getPlugin('content', 'jcscontent');
		$cnf = new JParameter($plugin->params);
		$uri = &JFactory::getURI();

		if($this->params->get('skip_for', 0) && ($my->gid >= $this->params->get('skip_for') && $my->gid <= 25))
		{
			$article->text = preg_replace("/{JCSBOT USER=[^}]+}/iU", "", $article->text);
			$article->text = preg_replace("/{JCSBOT SUBSCRIPTION=[^}]+}/iU", "", $article->text);
			if (preg_match("/{JCSBOT SKIP}/", $article->text))
			{
				$article->text = preg_replace("/{JCSBOT SKIP}/", "", $article->text);
			}
			return;
		}
		if($this->params->get('skip_author', 0))// && (JRequest::getVar('option') == 'com_content' && $view == 'article'))
		{
			$sql = "SELECT created_by FROM #__content WHERE id = '".$article->id."'";
			$db->setQuery($sql);
			$author = $db->loadResult();
			if($author == $userid)
			{
				$article->text = preg_replace("/{JCSBOT USER=[^}]+}/iU", "", $article->text);
				$article->text = preg_replace("/{JCSBOT SUBSCRIPTION=[^}]+}/iU", "", $article->text);
				if (preg_match("/{JCSBOT SKIP}/", $article->text))
				{
					$article->text = preg_replace("/{JCSBOT SKIP}/", "", $article->text);
				}
				return;
			}
		}
		if($this->params->get('skip_x_days', 0))// && (JRequest::getVar('option') == 'com_content' && $view == 'article'))
		{
			$sql = "SELECT IF(NOW() > created + INTERVAL ".$this->params->get('skip_x_days', 0)." DAY, 1, 0) as skip
			FROM #__content WHERE id = '".$article->id."'";
			$db->setQuery($sql);
			if($result = $db->loadObject())
			{
				if($result->skip)
				{
					$article->text = preg_replace("/{JCSBOT USER=[^}]+}/iU", "", $article->text);
					$article->text = preg_replace("/{JCSBOT SUBSCRIPTION=[^}]+}/iU", "", $article->text);
					if (preg_match("/{JCSBOT SKIP}/", $article->text))
					{
						$article->text = preg_replace("/{JCSBOT SKIP}/", "", $article->text);
					}
					return;
				}
			}
		}

		$url = $session->get('jcs_access_url');
		$current = $uri->toString();

		if ($url == $current)
		{
			$session->clear('jcs_access_url');
		}

		if ($cnf->get('se', 1))
		{
			$bots = explode("\n", $cnf->get('bots'));
			foreach($bots as $bot)
			if (strpos($_SERVER['HTTP_USER_AGENT'], $bot))
			return;
		}

		if ($view == 'article' && JRequest::getInt('id'))
		{
			$return = true;

		}
		else
		{
			$article->text = preg_replace("/{JCSBOT USER=[^}]+}/iU", "", $article->text);
			$article->text = preg_replace("/{JCSBOT SUBSCRIPTION=[^}]+}/iU", "", $article->text);
			$return = false;
		}

		if (preg_match("/{JCSBOT SKIP}/", $article->text))
		{
			$article->text = preg_replace("/{JCSBOT SKIP}/", "", $article->text);
			return false;
		}

		// Firs start to check categry restrict
		$query = "SELECT id, category, params, invisible " . "\n FROM #__jcs_plans WHERE published = 1 AND `type_category` = 1 AND `category` != ''";
		$db->setQuery($query);
		$categories = $db->loadObjectList();

		$sid = array();
		foreach($categories as $cat)
		{
			//if(!$cat->invisible)
			if($article->catid == $cat->category)
			$sid[] = $cat->id;
		}
		$categories = jcsGetCategories($categories);

		if ($categories && in_array($article->catid, $categories))
		{
			if (! $userid)
			{
				if ($return)
				jcsRestrictC($sid);
				jcsMarkTitle($article, $cnf);
				return;
			}
			$subscr = jcsGetSubscr('category', $userid, $db, implode(", ", $sid));
			if ($subscr)
			{
				$uscat = jcsGetCategories($subscr);
				///print_r($uscat);
				///echo $article->catid;


				if (! in_array($article->catid, $uscat))
				{
					if ($return)
					jcsRestrictC($sid);
					jcsMarkTitle($article, $cnf);
					return;
				}
				foreach($subscr as $row)
				{
					if ($return)
					jcsUpdateArticle('type_category', $row->subscription_id, $row->params, $row->id);
				}
				jcsMarkSubscribedTitle($article, $cnf);
				unset($subscr, $row);
			}
			else
			{
				if ($return)
				jcsRestrictC($sid);
				jcsMarkTitle($article, $cnf);
				return;
			}
		}

		// test user id based subscription
		if (preg_match("/{JCSBOT USER=([\d,]+)}/iU", $article->fulltext, $matches))
		{
			$article->text = preg_replace("/{JCSBOT USER=[^}]+}/iU", "", $article->text);
			$ids = explode(",", $matches[1]);

			if (! in_array($userid, $ids) || ! $userid)
			{
				if ($return)
				jcsRestrictC($sid);
				jcsMarkTitle($article, $cnf);
				return;
			}
			$subscr = jcsGetSubscr('user', $userid, $db);
			$sids = jcsGetUserIndividualizationPlans();

			if ($subscr)
			{
				if (count($subscr) <= 0)
				{
					if ($return)
					jcsRestrictC($sids);
					jcsMarkTitle($article, $cnf);
					return;
				}
				foreach($subscr as $row)
				{
					if ($return)
					jcsUpdateArticle('type_user', $row->subscription_id, $row->params, $row->id);
				}
				jcsMarkSubscribedTitle($article, $cnf);
				unset($subscr, $row);
			}
			else
			{
				$plans = array();
				if($sids)
				$plans = explode(',', $sids);
				if(count($plans))
				{
					if ($return)
					jcsRestrictC($sids);
					jcsMarkTitle($article, $cnf);
				}
				return;
			}
		}

		//test suscription based
		if (preg_match("/{JCSBOT SUBSCRIPTION=([\d,]+)}/iU", $article->text, $matches))
		{

			$article->text = preg_replace("/{JCSBOT SUBSCRIPTION=[^}]+}/iU", "", $article->text);

			if (! $userid)
			{
				if ($return)
				jcsRestrictC($matches[1]);
				jcsMarkTitle($article, $cnf);
				return;
			}
			$subscr = jcsGetSubscr('article', $userid, $db, $matches[1]);
			$sids = jcsGetArticleIndividualizationPlans();

			if ($subscr)
			{
				if (count($subscr) <= 0)
				{
					if ($return)
					jcsRestrictC($matches[1]);
					jcsMarkTitle($article, $cnf);
					return;
				}
				foreach($subscr as $row)
				{
					if ($return)
					jcsUpdateArticle('type_article', $row->subscription_id, $row->params, $row->id);
				}
				jcsMarkSubscribedTitle($article, $cnf);
			}
			else
			{
				$plans = array();
				if($sids)
				$plans = explode(',', $sids);
				if(count($plans))
				{
					if ($return || !in_array($matches[1], $plans))
					jcsRestrictC($matches[1]);

					jcsMarkTitle($article, $cnf);
				}
				return;
			}
		}

		return '';
	}
}
function jcsGetUserIndividualizationPlans()
{
	$db = &JFactory::getDBO();
	$sql = "SELECT id FROM #__jcs_plans WHERE type_user = 1 AND published = 1 AND invisible = 0";
	$db->setQuery($sql);
	$ids = $db->loadResultArray();
	return implode(",", $ids);
}
function jcsGetArticleIndividualizationPlans()
{
	$db = &JFactory::getDBO();
	$sql = "SELECT id FROM #__jcs_plans WHERE type_article = 1 AND published = 1 AND invisible = 0";
	$db->setQuery($sql);
	$ids = $db->loadResultArray();
	return implode(",", $ids);
}

function jcsGetSubscr($type, $userid, $db, $ids = '')
{
	$url = &JFactory::getURI();
	$return = false;
	/*$sql = "
	 SELECT u.subscription_id, s.params, u.id, s.`category`, SUM(u.access_count) access_count, SUM(u.access_limit) access_limit,
	 IF(u.access_limit > 0, IF(SUM(u.access_count) >= SUM(u.access_limit), 0, 1), 1) AS cl
	 FROM #__jcs_user_subscr AS u
	 LEFT JOIN #__jcs_plans AS s ON s.id = u.subscription_id
	 WHERE u.user_id = {$userid}
	 AND u.extime > NOW()
	 AND u.ctime < NOW()
	 AND u.published = 1
	 AND s.`type_$type` = 1
	 " . ($ids ? " AND s.id IN ({$ids}) " : null) . "
	 GROUP BY u.subscription_id
	 ORDER BY u.ctime DESC";*/

	$sql = "SELECT u.subscription_id, s.params, u.id, s.`category`, u.access_count, u.access_limit
	FROM #__jcs_user_subscr AS u
	LEFT JOIN #__jcs_plans AS s ON s.id = u.subscription_id
	WHERE u.user_id = {$userid}
	AND u.extime > NOW()
	AND u.ctime < NOW()
	AND u.published = 1
	AND s.`type_$type` = 1
        " . ($ids ? " AND u.subscription_id IN ({$ids}) " : null) . "    
    ORDER BY u.ctime DESC";

	$db->setQuery($sql);
	$res = $db->loadObjectList();

	foreach($res as $item)
	{
		$params = new JParameter($item->params);
		if($params->get('count_limit_mode') && $item->access_limit && $item->access_count >= $item->access_limit)
		{
			$sql = "SELECT url FROM #__jcs_history WHERE user_id = '{$userid}' and subscription_id= '{$item->subscription_id}'";
			$db->setQuery($sql);
			$urls = $db->loadResultArray();

			if($params->get('count_limit_mode') == '1' && in_array($url->toString(), $urls))
			return $res;
		}
		else
		return $res;
	}
	return $return;
}
function jcsMarkTitle(&$row, $param)
{
	global $Itemid;
	if ($param->def('mark') == 0)
	return;

	$user = JFactory::getUser();

	if($param->get('skip_author', 0) && $row->created_by == $user->id)
	return $row;


	$sign = $param->def('pic');
	$img = sprintf('<img src="%s" alt="Subscribe" border="0" align="absmiddle" class="jcslock" /> %s', $sign, $param->def('pic_text'));
	if ($param->def('link') == 1)
	{
		$img = sprintf('<a href="%s">%s</a>', JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&Itemid=' . $Itemid), $img);
	}
	switch ($param->def('mark_type'))
	{
		case 0 :
			$row->title = $img . ' ' . $row->title;
			break;

		case 1 :
			$row->title .= ' ' . $img;
			break;

		case 2 :
			$class = '<style type="text/css">.jcslock{float:left}</style>';
			$row->text = $class . $img . ' ' . $row->text;
			break;

		case 3 :
			$row->text .= ' <BR>' . $img;
			break;
	}
	return $row;
}

function jcsMarkSubscribedTitle(&$row, $param)
{
	global $Itemid;
	if ($param->def('mark') == 0)
	return;

	$user = JFactory::getUser();

	if($param->get('skip_author', 0) && $row->created_by == $user->id)
	return $row;

	$sign = $param->def('pic_subscr');
	$text = $param->def('pic_subscr_text');

	if(!$sign && !$text) return ;

	if($sign)
	$img = sprintf('<img src="%s" alt="Subscribe" border="0" align="absmiddle" class="jcslock" /> %s', $sign, $text);
	else
	$img = $text;
	if ($param->def('link') == 1)
	{
		$img = sprintf('<a href="%s">%s</a>', JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&Itemid=' . $Itemid), $img);
	}
	switch ($param->def('mark_type'))
	{
		case 0 :
			$row->title = $img . ' ' . $row->title;
			break;

		case 1 :
			$row->title .= ' ' . $img;
			break;

		case 2 :
			$class = '<style type="text/css">.jcslock{float:left}</style>';
			$row->text = $class . $img . ' ' . $row->text;
			break;

		case 3 :
			$row->text .= ' <BR>' . $img;
			break;
	}
	return $row;
}

function jcsUpdateArticle($type, $id = FALSE, $params, $sid = false)
{

	$db = & JFactory::getDBO();
	$my = & JFactory::getUser();
	$userid = $my->get('id');
	$uri = &JFactory::getURI();
	$url = $uri->toString();

	$params = new JParameter($params);

	if($params->get('count_limit_mode') == 1)
	{
		$sql = "SELECT id FROM  #__jcs_history WHERE user_id = '$userid' AND url = '{$url}'";
		/*if ($id)
		 $sql .= " AND subscription_id = " . $id;*/
		$db->setQuery($sql);
		$hid = $db->loadResult();
		if (! $hid)
		{
			$sql2 = "INSERT INTO #__jcs_history VALUES (NULL, '$userid', '{$url}', NOW(), '{$id}')";

			$db->setQuery($sql2);
			$db->query();
		}
		else
		{
			return;
		}
	}
	if($params->get('count_limit_mode'))
	{
		$sql = "
		UPDATE #__jcs_user_subscr AS u, #__jcs_plans AS s
		SET u.access_count = u.access_count + 1
		WHERE u.subscription_id = s.id
		AND s.$type = 1 " . ($id ? " AND u.subscription_id = '{$id}'" : "") . " AND u.user_id = '{$userid}'
		AND u.id = '$sid' AND u.access_count < u.access_limit";
		$db->setQuery($sql);
		$db->query();
		
	}
}

function jcsGetCategories($array)
{
	if (count($array) > 0)
	{
		$restrict = array();
		foreach($array as $arr)
		{
			$restrict = array_merge($restrict, explode(",", $arr->category));
		}
		$restrict = array_flip($restrict);
		$restrict = array_flip($restrict);
		return $restrict;
	}
	return FALSE;
}

function jcsRestrictC($sid = false)
{
	global $mainframe;
	/*$plans = $sid;
	$db = JFactory::getDBO();
	$sql = "SELECT id, invisible FROM #__jcs_plans WHERE id IN ( $sid )";
	$db->setQuery($sql);
	if($res = $db->loadObjectList())
	{
		$ids = array();
		if(!is_array($plans)) settype($plans, 'array');
		foreach ($res as $val)
		{
			if(in_array($val->id, $plans) && !$val->invisible )
			{
				$ids[] = $val->id;
			}
		}
		$sid = implode(',', $ids);
	}*/
	
	if(is_array($sid)) $sid = implode(",", $sid);
	$sid = preg_replace("/[^0-9,]+/iU", "", $sid);
	$Itemid = JRequest::getInt('Itemid');
	if(JCS_IID_PLANS) $Itemid = JCS_IID_PLANS;

	$session = & JFactory::getSession();
	$uri = &JFactory::getURI();
	$url = $uri->toString();

	$current = JURI::base() . ereg_replace("^/", "", $_SERVER['REQUEST_URI']);
	$session->set('jcs_access_url', $url);

	//$mainframe->redirect(JRoute::_("index.php?option=com_jcs&view=jcs&layout=form&Itemid=".$Itemid));
	$link = "index.php?option=com_jcs&view=jcs&layout=form&Itemid=" . $Itemid;
	//$link .= "&subscr_id=".implode(",", $sid)."&id=".$sid;

	if($sid) $link .= "&id=".$sid;

	$mainframe->redirect(JRoute::_($link, false));
}